import { Component, OnInit } from '@angular/core';
import { FormArray, FormBuilder, FormGroup } from '@angular/forms';

@Component({
  selector: 'app-veriable-form',
  templateUrl: './veriable-form.component.html',
  styleUrls: ['./veriable-form.component.sass']
})
export class VeriableFormComponent implements OnInit {
  formGroup: FormGroup;
  variableList = ['Variable1', 'Variable2', 'Variable3'];  // Example variable list

  constructor(private fb: FormBuilder) {
    this.formGroup = this.fb.group({
      items: this.fb.array([this.createItem()])
    });
  }

  ngOnInit(): void {

  }

  get items() {
    return this.formGroup.get('items') as FormArray;
  }

  createItem(): FormGroup {
    return this.fb.group({
      type: [''],
      variable: [''],
      text: ['']
    });
  }

  addRow() {
    this.items.push(this.createItem());
  }

  removeRow(index: number) {
    this.items.removeAt(index);
  }

  onTypeChange(index: number) {
    const type = this.items?.at(index)?.get('type')?.value;
    if (type === 'variable') {
      this.items?.at(index)?.get('text')?.setValue('');
    } else {
      this.items?.at(index)?.get('variable')?.setValue('');
    }
  }

  calculateVariable(index: number): string {
    const selectedVariable = this.items?.at(index)?.get('variable')?.value;
    return `Calculated value for ${selectedVariable}`;
  }

  onSubmit() {
      const formData = this.formGroup.value;
      console.log(formData);

  }

}
